From d7dfa262de1bd6c04ab2dfefef8ddb1631dce1a8 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 14 2020 00:54:50 +0000
Subject: [PATCH 1374/2232] Merge pull request #468 from dtolnay/book


Preapply hljs to provide highlighting for browsers with JS off
---

diff --git a/book/book.toml b/book/book.toml
index d3187e0..fe8b5fc 100644
--- a/book/book.toml
+++ b/book/book.toml
@@ -10,5 +10,6 @@ edition = "2018"
 build-dir = "build"
 
 [output.html]
+additional-css = ["css/cxx.css"]
 cname = "cxx.rs"
 git-repository-url = "https://github.com/dtolnay/cxx"
diff --git a/book/build.js b/book/build.js
index a9278db..d4396fe 100755
--- a/book/build.js
+++ b/book/build.js
@@ -2,6 +2,9 @@
 
 const fs = require('fs');
 const cheerio = require('cheerio');
+const hljs = require('./build/highlight.js');
+const Entities = require('html-entities').AllHtmlEntities;
+const entities = new Entities();
 
 const githublink = `\
 <li class="part-title">\
@@ -30,6 +33,36 @@ while (dirs.length) {
     const $ = cheerio.load(index, { decodeEntities: false });
 
     $('nav#sidebar ol.chapter').append(githublink);
+    $('pre code').each(function () {
+      const node = $(this);
+      const langClass = node.attr('class').split(' ', 2)[0];
+      if (!langClass.startsWith('language-')) {
+        return;
+      }
+      const lang = langClass.replace('language-', '');
+      const lines = node.html().split('\n');
+      const boring = lines.map((line) =>
+        line.includes('<span class="boring">')
+      );
+      const target = entities.decode(node.text());
+      const highlighted = hljs.highlight(lang, target).value;
+      const result = highlighted
+        .split('\n')
+        .map(function (line, i) {
+          if (boring[i]) {
+            line = '<span class="boring">' + line;
+          }
+          if (i > 0 && boring[i - 1]) {
+            line = '</span>' + line;
+          }
+          return line;
+        })
+        .join('\n');
+      node.text(result).removeClass(langClass).addClass('hidelines');
+    });
+    $('code').each(function () {
+      $(this).addClass('hljs');
+    });
 
     const out = $.html();
     fs.writeFileSync(path, out);
